unit Childwin;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, ExtCtrls,
        header;

type
  TMDIChild = class(TForm)
    imgView: TImage;
    imgWork: TImage;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormActivate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure imgViewDblClick(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
  private
    { Private 錾 }

    CoreCube3DPoint: array [1..27] of T3DData;
    CoreCube3DLine : array [1..22] of T3DLine;
    IsMouseDown : boolean;      // }EX
    IsDoubleClick: boolean;     // }EX

    OldCenterPt : T3DData;
    MoveCenterPt : T3DData;
    StartDragPt : T3DData;
    StartDragImm : Integer;


    procedure SetCC3DPoint();
    procedure SetCC3DLines();
    procedure CalcPoint();
    procedure WriteCube();
    procedure WritePoint();
    procedure WriteLine();
    procedure ScanPoint(X,Y: integer; L: double; Shift: TShiftState);
    procedure PutPoint(X,Y: integer; SynmMode: Boolean);
    procedure MovPoint(X,Y: integer; SynmMode: boolean);
    procedure MovCenterPtPoint(X,Y: integer; Vz: Double);
    procedure RemPoint(SynmMode: Boolean);
    procedure PutLine(P1, P2: integer);
    procedure RemLine();
    procedure DelLine(P1, P2: integer);
//   procedure callLdiv(p3d,v3d: T3DPoint; Pdist: integer);
    procedure callLdiv(p3d,v3d: T3DPoint; Pdist: integer;
                var linebuff: array of TPoint; var lineSP: integer);



  public
    { Public 錾 }
    procedure SetLensType(lt: TLensType);
    procedure WriteChild(LocateX, LocateY : double);
    procedure WriteWindow();

  protected
    ChildCStat : TCwinStatus;  // `ChEBhEXe[^X

    ChildCStat_NextPStat : Integer;
    ChildCStat_NextPNo : Integer;


  end;

implementation

uses Main, locater, functions;

{$R *.DFM}

//-----------------------------------------------------------------------------
// NGCg
//-----------------------------------------------------------------------------
procedure TMDIChild.FormCreate(Sender: TObject);
begin
  ChildCStat.PPlainL  := 1.5;
  ChildCStat.PCameraL := 4.0;
  ChildCStat.LensType := tlPars;

  ChildCStat.Offset2D.X := 0;
  ChildCStat.Offset2D.Y := 0;
  ChildCStat.Expan2D := 0.80;

  ChildCStat.Offset3D.X := 0;
  ChildCStat.Offset3D.Y := 0;
  ChildCStat.Offset3D.Z := 0;

  ChildCStat.Wwidth :=ClientWidth;
  ChildCStat.Wheight :=Clientheight;

  ChildCStat_NextPStat := PT_NULL;
  ChildCStat_NextPNo := 0;              //hbNn߂_̔ԍƏ

  imgView.Canvas.FillRect(Rect(0,0,imgView.Width, imgView.Height));
  imgView.Width := ClientWidth;
  imgView.Height := ClientHeight;


  IsMouseDown := False;
  IsDoubleClick := false;
  SetCC3DPoint();
  SetCC3DLines();
  WriteChild(0,0);

end;

//-----------------------------------------------------------------------------
// 
//-----------------------------------------------------------------------------
procedure TMDIChild.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;

//-----------------------------------------------------------------------------
// TCY
//-----------------------------------------------------------------------------
procedure TMDIChild.FormResize(Sender: TObject);
begin

  ChildCStat.Wwidth :=ClientWidth;
  ChildCStat.Wheight :=Clientheight;

  imgView.Width := ClientWidth;
  imgView.Height := ClientHeight;

  WriteChild(ChildCStat.Xtheta, ChildCStat.Ytheta);
end;

//-----------------------------------------------------------------------------
// ANeBu
//-----------------------------------------------------------------------------
procedure TMDIChild.FormActivate(Sender: TObject);
var
  i :integer;
begin
  LocaterForm.SetIdoKeido(ChildCStat.Xtheta, ChildCStat.Ytheta);
  WriteChild(ChildCStat.Xtheta, ChildCStat.Ytheta);
  case ChildCStat.LensType of
    tlOrtho:      MainForm.Camera_typeOrthogonal.Checked := true;
    tlPars:       MainForm.Camera_typePerspective.Checked := true;
    tlOrtholens:  MainForm.Camera_typeOrthogonalLens.Checked := true;
    tlEquidlens:  MainForm.Camera_typeEquidistanceLens.Checked := true;
  end;

    for i:=1 to MaxAryPoint
    do begin
      //MainForm.Ary3DData[i].Status := MainForm.Ary3DData[i].Status and (not PT_Selected);
    end;
end;

//-----------------------------------------------------------------------------
// fBANeBu
//-----------------------------------------------------------------------------
procedure TMDIChild.FormDeactivate(Sender: TObject);
//var
//  NewL, AddL: P3DLine;
begin
//  MainForm.CountTemp := 0;
{  AddL := MainForm.Lnk3DLineTmp;
  while nil <> AddL
  do begin
    NewL := AddL;
    AddL := AddL.NextL;
    Dispose(NewL);
  end;
  MainForm.Lnk3DLineTmp := nil;  }
end;

//-----------------------------------------------------------------------------
// }EX{^_E
//-----------------------------------------------------------------------------
procedure TMDIChild.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
//var
//  i: integer;
//  New3DD: P3DData;
//  Work3D: T3DPoint;
//  WorkPT: T2DPoint;
//  NewL, AddL: P3DLine;
begin
WriteWindow;

  if IsDoubleClick
  then begin
    IsDoubleClick := false;
    exit;
  end;
  IsMouseDown := true;

  if MainForm.Mode_DrowLine.Checked or MainForm.Mode_DrowLineSynm.Checked
  then begin // _u[h
    if mbLeft = Button
    then begin
      PutPoint(X, Y, MainForm.Mode_DrowLineSynm.Checked);
    end;
    if mbRight = Button
    then begin
      RemPoint(MainForm.Mode_DrowLineSynm.Checked);
    end;
  end

  else begin // _ړ[h
    ScanPoint(X, Y, Mainform.AppStat_CatchPointLength, Shift);
    OldCenterPt := MoveCenterPt;
  end;
end;

//-----------------------------------------------------------------------------
// }EX{^ړ
//-----------------------------------------------------------------------------
procedure TMDIChild.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
  tmp3d :T3DPoint;
  Vz    :Double;
begin
//
  if MainForm.Mode_DrowLine.Checked or MainForm.Mode_DrowLineSynm.Checked
  then begin // _u[hA܂
    if (true = Self.Active) and
       (0 <> MainForm.MovingPoint)
    then begin
      MovPoint(X, Y, MainForm.Mode_DrowLineSynm.Checked);
    end;
  end
  else begin // _ړ[hAhbO
    if IsMouseDown
    then begin
      tmp3d := Wxyz2Vxyz(OldCenterPt.World,ChildCStat.Xtheta, ChildCStat.Ytheta,ChildCStat.Offset3D);
      Vz := tmp3d.Z;
      OldCenterPt := MoveCenterPt;
      MovCenterPtPoint(X, Y, Vz);

//      MainForm.UpdateCameraStat(MoveCenterPt, ChildCStat);
    end;
  end;
end;

//-----------------------------------------------------------------------------
// }EX{^Abv
//-----------------------------------------------------------------------------
procedure TMDIChild.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  IsMouseDown := false;
  if MainForm.Mode_DrowLine.Checked or MainForm.Mode_DrowLineSynm.Checked
  then begin // _u
  end
  else begin // _ړ

    if 0 < ChildCStat_NextPNo
    then begin
      MainForm.Ary3DData[ChildCStat_NextPNo].Status := ChildCStat_NextPStat;
      ChildCStat_NextPNo := 0;

      MainForm.UpdateCameraStat(MoveCenterPt, ChildCStat);
    end;

  end;
end;

//-----------------------------------------------------------------------------
// }EX_uNbN
//-----------------------------------------------------------------------------
procedure TMDIChild.imgViewDblClick(Sender: TObject);
//var
//  i, j: integer;
//  AddL: P3DLine;
begin
  if MainForm.Mode_DrowLine.Checked or MainForm.Mode_DrowLineSynm.Checked
  then begin // _u
    RemPoint(MainForm.Mode_DrowLineSynm.Checked);
    MainForm.MovingPoint := 0;
    IsDoubleClick := true;

    ChildCStat.Immidiate := 0;
    if MainForm.Mode_DrowLineSynm.Checked then ChildCStat.Immidiate := 1;

    MainForm.UpdateCameraStat(MoveCenterPt, ChildCStat);
  end
  else begin // _ړ
  end;
end;

//-----------------------------------------------------------------------------
// Y^CvύX
//-----------------------------------------------------------------------------
procedure TMDIChild.SetLensType(lt: TLensType);
begin
  ChildCStat.LensType := lt;
end;

//-----------------------------------------------------------------------------
// SĂ̕`
//-----------------------------------------------------------------------------
procedure TMDIChild.WriteChild(LocateX, LocateY: double);
begin
  ChildCStat.Xtheta := LocateX;
  ChildCStat.Ytheta := LocateY;

  ChildCStat.Camera3D :=CheckCamera3d(ChildCStat);

  MainForm.StatusBar.Panels[2].Text := Format('%dJ: %f %f %f',[ChildCStat.Immidiate,ChildCStat.Camera3D.X ,ChildCStat.Camera3D.Y ,ChildCStat.Camera3D.Z]);

  MainForm.StatusBar.Panels[4].Text := Format('%dJ: %f %f %f',[MainForm.DatStat_OldCam.Immidiate,MainForm.DatStat_OldCam.Camera3D.X ,MainForm.DatStat_OldCam.Camera3D.Y ,MainForm.DatStat_OldCam.Camera3D.Z]);

  MainForm.StatusBar.Panels[5].Text := Format('%dJ: %f %f %f',[Mainform.DatStat_CmpCam.Immidiate,Mainform.DatStat_CmpCam.Camera3D.X,Mainform.DatStat_CmpCam.Camera3D.Y,Mainform.DatStat_CmpCam.Camera3D.Z]);


//  WriteCube();
//  WriteLines();
end;

//-----------------------------------------------------------------------------
// _ʒuvZ
//-----------------------------------------------------------------------------
procedure TMDIChild.CalcPoint();
var
  i: integer;
  r3d : T3DPoint;
  r2d : T2DPoint;
  f2d : T2DPoint;


begin

  MainForm.Ary3DData[0] := MoveCenterPt;  //dS0ɓ

  for i := 0 to MaxAryPoint
  do begin
    if 0 <> (PT_Alived and MainForm.Ary3DData[i].Status)
    then begin
      r3d := Wxyz2Vxyz(MainForm.Ary3DData[i].World,
                       ChildCStat.Xtheta, ChildCStat.Ytheta, ChildCStat.Offset3D);
      r2d := Vxyz2Pxy(r3d, ChildCStat.PPlainL, ChildCStat.PCameraL,
                      ChildCStat.LensType, ChildCStat.Offset2D, ChildCStat.Expan2D);
      f2d := Pxy2Fxy(r2d,ChildCStat.Wwidth,ChildCStat.Wheight); //l

      MainForm.Ary3DData[i].Flat.x := Roundoff(f2d.X); //l
      MainForm.Ary3DData[i].Flat.y := Roundoff(f2d.Y); //l

      if true = self.Active
      then begin
        MainForm.Ary3DData[i].Flat3D.X := r2d.X;
        MainForm.Ary3DData[i].Flat3D.Y := r2d.Y;
        MainForm.Ary3DData[i].Flat3D.Z := r3d.Z;
      end;
    end;
  end;

  MoveCenterPt := MainForm.Ary3DData[0];   //dS֔f
  MainForm.StatusBar.Panels[3].Text := Format('%d dS: %f %f %f',[MoveCenterPt.Status,MoveCenterPt.World.X,MoveCenterPt.World.Y,MoveCenterPt.World.Z]);

  MainForm.StatusBar.Panels[2].Text := Format('%dJ: %f %f %f',[ChildCStat.Immidiate,ChildCStat.Camera3D.X ,ChildCStat.Camera3D.Y ,ChildCStat.Camera3D.Z]);

  MainForm.StatusBar.Panels[4].Text := Format('%dJ: %f %f %f',[MainForm.DatStat_OldCam.Immidiate,MainForm.DatStat_OldCam.Camera3D.X ,MainForm.DatStat_OldCam.Camera3D.Y ,MainForm.DatStat_OldCam.Camera3D.Z]);

  MainForm.StatusBar.Panels[5].Text := Format('%dJ: %f %f %f',[Mainform.DatStat_CmpCam.Immidiate,Mainform.DatStat_CmpCam.Camera3D.X,Mainform.DatStat_CmpCam.Camera3D.Y,Mainform.DatStat_CmpCam.Camera3D.Z]);

end;

//-----------------------------------------------------------------------------
// _
//-----------------------------------------------------------------------------
procedure TMDIChild.ScanPoint(X, Y: integer; L: double; Shift: TShiftState);
var
  SelectNo, i: integer;
  f2d: T2DPoint;
  p2d: T2DPoint;

  DistL: double;
begin
  SelectNo := -1;
  for i := 1 to MaxAryPoint
  do begin
    if 0 <> (PT_Alived and MainForm.Ary3DData[i].Status)
    then begin
      p2d.X := MainForm.Ary3DData[i].Flat3D.X;
      p2d.Y := MainForm.Ary3DData[i].Flat3D.Y;
      f2d := Pxy2Fxy(p2d ,ChildCStat.Wwidth,ChildCStat.Wheight);
      p2d.X := X;
      p2d.Y := Y;
      DistL := len2d(f2d,p2d);


      if DistL <= L   //덷͈͓łł
      then begin
        if MainForm.Ary3DData[i].Flat3D.Z > -(ChildCStat.PPlainL + ChildCStat.PCameraL)
        then begin
          if SelectNo < 0
          then begin
            SelectNo := i;
          end
          else begin
            if (MainForm.Ary3DData[i].Flat3D.Z < MainForm.Ary3DData[SelectNo].Flat3D.Z)
            then begin
              SelectNo := i;
            end;
          end;
        end
      end;
    end;
  end;
  if SelectNo >= 0
  then begin            //@_߂ĂƂ
    MoveCenterPt := MainForm.Ary3DData[SelectNo];
    StartDragPt := MoveCenterPt;
    StartDragImm := MoveCenterPt.Immidiate;
    ChildCStat.Immidiate := StartDragImm;

      MainForm.UpdateCameraStat(MoveCenterPt, ChildCStat);

    if ssSHIFT in Shift
    then begin // VtgĂ
      if 0 = (MainForm.Ary3DData[SelectNo].Status and PT_Selected)
      then begin // I
//        MainForm.Ary3DData[SelectNo].Status := MainForm.Ary3DData[SelectNo].Status or PT_Selected;
        ChildCStat_NextPStat := MainForm.Ary3DData[SelectNo].Status or PT_Selected;
        ChildCStat_NextPNo := SelectNo ;
      end
      else begin // INA
//        MainForm.Ary3DData[SelectNo].Status := MainForm.Ary3DData[SelectNo].Status and (not PT_Selected);
        ChildCStat_NextPStat := MainForm.Ary3DData[SelectNo].Status and (not PT_Selected);
        ChildCStat_NextPNo := SelectNo ;
      end;

      MainForm.Ary3DData[SelectNo].Status := MainForm.Ary3DData[SelectNo].Status or PT_Selected;

    end
    else begin // VtgĂȂ
      //if 0 = (MainForm.Ary3DData[SelectNo].Status and PT_Selected)
      //then begin
        for i:=1 to MaxAryPoint
        do begin // SINA
          MainForm.Ary3DData[i].Status := MainForm.Ary3DData[i].Status and (not PT_Selected);
        end;
      //end;
      MainForm.Ary3DData[SelectNo].Status := MainForm.Ary3DData[SelectNo].Status or PT_Selected;
    end;
  end
  else begin            //@_łȂƂ
    MoveCenterPt.Status := (MoveCenterPt.Status and (not PT_Alived));
    if ssSHIFT in Shift
    then begin // VtgĂ
    end
    else begin // VtgĂȂ
      for i:=1 to MaxAryPoint
      do begin // SINA
        MainForm.Ary3DData[i].Status := MainForm.Ary3DData[i].Status and (not PT_Selected);
      end;
    end;
  end;
end;

//-----------------------------------------------------------------------------
// _uAŏ̈_
//-----------------------------------------------------------------------------
procedure TMDIChild.PutPoint(X, Y: integer; SynmMode: Boolean);
var
  i, NewN ,NewNSyn: integer;
  New3DD ,New3DDSyn: T3DData;
  Work3D: T3DPoint;

  WorkPT: T2DPoint;

  WorkFT: T2DPoint;
//  NewL, AddL: P3DLine;
begin
  New3DD.Group := 0;
  New3DD.View := 0;
  New3DD.Status := PT_Alived;
  New3DD.Immidiate := 0; // Ώ
  New3DD.Dim := 0;// Ώ
  New3DD.Flat.X := X;
  New3DD.Flat.Y := Y;


  WorkFT.X := X;
  WorkFT.Y := Y;
  WorkPT := Fxy2Pxy(WorkFT,ChildCStat.Wwidth,ChildCStat.Wheight);

  Work3D := PxyVz2Vxyz(WorkPT, 0, ChildCStat.PPlainL, ChildCStat.PCameraL,
                       ChildCStat.LensType, ChildCStat.Offset2D, ChildCStat.Expan2D);

  New3DD.World := Vxyz2Wxyz(Work3D, ChildCStat.Xtheta, ChildCStat.Ytheta,
                            ChildCStat.Offset3D);

  NewN := 0;
  for i:= 1 to MaxAryPoint
  do begin
    if 0 = (MainForm.Ary3DData[i].Status and PT_Alived) // gp_
    then begin
      NewN := i;
      MainForm.Ary3DData[i].Status := PT_Alived;
      New3DD.Number := MainForm.MovingPoint;
      break;
    end;
  end;

  if SynmMode
  then begin //
    New3DDSyn.Group := 0;
    New3DDSyn.View := 0;
    New3DDSyn.Status := PT_Alived;
    New3DDSyn.Immidiate := -1; // Ώ̋
    New3DDSyn.Dim := New3DD.Number; //Ώ̓_ԍ

    New3DDSyn.World.X := -(New3DD.World.X);
    New3DDSyn.World.Y :=  (New3DD.World.Y);
    New3DDSyn.World.Z :=  (New3DD.World.Z);

    Work3D := Wxyz2Vxyz(New3DDsyn.World,ChildCStat.Xtheta, ChildCStat.Ytheta, ChildCStat.Offset3D);
    WorkPT := Vxyz2Pxy(Work3D,ChildCStat.PPlainL, ChildCStat.PCameraL,ChildCStat.LensType,ChildCStat.Offset2D, ChildCStat.Expan2D);
    WorkFT := Pxy2Fxy(WorkPT ,ChildCStat.WWidth, ChildCStat.Wheight);

    New3DDSyn.Flat.X := Roundoff(WorkFT.X);
    New3DDSyn.Flat.Y := Roundoff(WorkFT.Y);

    New3DDSyn.Flat3D.X := WorkPT.X;
    New3DDSyn.Flat3D.Y := WorkPT.Y;
    New3DDSyn.Flat3D.Z := Work3D.Z;



    NewNSyn :=0;
    for i:= 1 to MaxAryPoint
    do begin
      if 0 = (MainForm.Ary3DData[i].Status and PT_Alived) // gp_
      then begin
        NewNSyn := i;
        MainForm.Ary3DData[i].Status := PT_Alived;
        //New3DDSyn.Number := MainForm.Ary3DData[MainForm.MovingPoint].Dim;
        break;
      end;
    end;
    New3DD.Immidiate := 1; //
    //New3DD.Dim       := New3DDSyn.Number;
  end;

  if 0 = MainForm.MovingPoint  //ŏ̓_A܂͒
  then begin // ŏ̓_
    MainForm.MKPAry[0].Elder := MKP_New;
    MainForm.MKPAry[0].PointNo := NewN;
    for i:= 1 to MaxAryPoint
    do begin
      if 0 = (MainForm.Ary3DData[i].Status and PT_Alived) // gp_
      then begin
        New3DD.Number := NewN; // ŏ̓_
        MainForm.Ary3DData[NewN] := New3DD;
        New3DD.Number := i;    // ړ_
        MainForm.Ary3DData[i] := New3DD;
        MainForm.MKPAry[1].Elder := MKP_New;
        MainForm.MKPAry[1].PointNo := i;
        MainForm.MKPAry[2].Elder := MKP_None;
        MainForm.MovingPoint := i;
        PutLine(NewN, i);
        break;
      end;
    end;
    if SynmMode
    then begin //
      for i:= 1 to MaxAryPoint
      do begin
        if 0 = (MainForm.Ary3DData[i].Status and PT_Alived) // gp_
        then begin
          MainForm.Ary3DData[NewN].Dim := NewNSyn;
          New3DDSyn.Number := NewNSyn; // ŏ̓_
          New3DDSyn.Dim    := NewN;
          MainForm.Ary3DData[NewNSyn] := New3DDSyn;
          New3DDSyn.Number := i;    // ړ_
          New3DDSyn.Dim := MainForm.MovingPoint;
          MainForm.Ary3DData[MainForm.MovingPoint].Dim := i;
          MainForm.Ary3DData[i] := New3DDSyn;
          PutLine(NewNSyn, i);
          break;
        end;
      end;
    end;
  end
  else begin // ȍ~̓_
    New3DD.Immidiate := MainForm.Ary3DData[MainForm.MovingPoint].Immidiate;
    New3DD.Dim       := MainForm.Ary3DData[MainForm.MovingPoint].Dim;
    MainForm.Ary3DData[MainForm.MovingPoint] := New3DD; // ()ړ_̌Œ
    New3DD.Immidiate := 0;
    New3DD.Dim       := 0;
    for i:= 2 to 254
    do begin // ̈ړ_̌
      if MKP_None = MainForm.MKPAry[i].Elder
      then begin
        New3DD.Number := NewN; // ̈ړ_
        MainForm.Ary3DData[NewN] := New3DD;
        MainForm.MKPAry[i].Elder := MKP_New;
        MainForm.MKPAry[i+1].Elder := MKP_None;
        MainForm.MKPAry[i].PointNo := NewN;
        PutLine(MainForm.MovingPoint, NewN);
        if SynmMode
        then begin
          MainForm.Ary3DData[NewN].Immidiate := 1;
          MainForm.Ary3DData[NewN].Dim       := NewNSyn;
          New3DDSyn.Number := MainForm.Ary3DData[MainForm.MovingPoint].Dim;
          New3DDSyn.Dim := MainForm.MovingPoint;
          MainForm.Ary3DData[MainForm.Ary3DData[MainForm.MovingPoint].Dim] := New3DDSyn; // ()ړ_̌Œ
          New3DDSyn.Number := NewNSyn;
          New3DDSyn.Dim := NewN;
          MainForm.Ary3DData[NewNSyn] := New3DDSyn;
          PutLine(MainForm.Ary3DData[MainForm.MovingPoint].Dim, NewNSyn);
        end;
        MainForm.MovingPoint := NewN; // ̈ړ_
        break;
      end;
    end;
  end;
end;

//-----------------------------------------------------------------------------
// ǉ_u@̓[h
//-----------------------------------------------------------------------------
procedure TMDIChild.MovPoint(X, Y: integer; SynmMode: boolean);
var
//  NewN  : integer;
  New3DD, New3DDSyn: T3DData;
  Work3D: T3DPoint;
  WorkPT: T2DPoint;
  WorkFT: T2DPoint;

begin
  //New3DD.Group := 0;
  //New3DD.View := 0;
  //New3DD.Status := PT_Alived; //p
  //New3DD.Immidiate := 0; // Ώ
  //New3DD.Dim := 0;// Ώ

  New3DD := MainForm.Ary3DData[MainForm.MovingPoint];

  New3DD.Flat.X := X;
  New3DD.Flat.Y := Y;

  WorkFT.X := X;
  WorkFT.Y := Y;
  WorkPT := Fxy2Pxy(WorkFT,ChildCStat.Wwidth,ChildCStat.Wheight);

  Work3D := PxyVz2Vxyz(WorkPT, 0, ChildCStat.PPlainL, ChildCStat.PCameraL,
                       ChildCStat.LensType, ChildCStat.Offset2D, ChildCStat.Expan2D);
  New3DD.World := Vxyz2Wxyz(Work3D, ChildCStat.Xtheta, ChildCStat.Ytheta,
                            ChildCStat.Offset3D);
  New3DD.Number := MainForm.MovingPoint;
  MainForm.Ary3DData[MainForm.MovingPoint] := New3DD;


  if SynmMode
  then begin
    New3DDSyn := MainForm.Ary3DData[MainForm.Ary3DData[MainForm.MovingPoint].Dim];

    New3DDSyn.World.X := -(New3DD.World.X);
    New3DDSyn.World.Y :=  (New3DD.World.Y);
    New3DDSyn.World.Z :=  (New3DD.World.Z);

    Work3D := Wxyz2Vxyz(New3DDsyn.World,ChildCStat.Xtheta, ChildCStat.Ytheta, ChildCStat.Offset3D);
    WorkPT := Vxyz2Pxy(Work3D,ChildCStat.PPlainL, ChildCStat.PCameraL,ChildCStat.LensType,ChildCStat.Offset2D, ChildCStat.Expan2D);
    WorkFT := Pxy2Fxy(WorkPT ,ChildCStat.WWidth, ChildCStat.Wheight);

    New3DDSyn.Flat.X := Roundoff(WorkFT.X);
    New3DDSyn.Flat.Y := Roundoff(WorkFT.Y);

    New3DDSyn.Flat3D.X := WorkPT.X;
    New3DDSyn.Flat3D.Y := WorkPT.Y;
    New3DDSyn.Flat3D.Z := Work3D.Z;

    MainForm.Ary3DData[MainForm.Ary3DData[MainForm.MovingPoint].Dim] := New3DDSyn;
  end;
end;

//-----------------------------------------------------------------------------
// _ړ
//-----------------------------------------------------------------------------
procedure TMDIChild.MovCenterPtPoint(X,Y: integer; Vz: Double);
var
//  NewN  : integer;
  New3DD: T3DData;
  Work3D: T3DPoint;
  WorkPT: T2DPoint;
  WorkFT: T2DPoint;

  tmp3d: T3Dpoint;

  op3d,tp3d,np3d : T3DPoint;
  SafeArea,SafeDeg : Double;
  ocamstat,ncamstat : TCwinStatus;

  tmp: integer;

  i: integer;
begin
  New3DD.Group := 0;
  New3DD.View := 0;
  New3DD.Status := MoveCenterPt.Status;
  New3DD.Immidiate := 0; // Ώ
  New3DD.Dim := 0;// Ώ
  New3DD.Flat.X := X;
  New3DD.Flat.Y := Y;

  WorkFT.X := X;
  WorkFT.Y := Y;
  WorkPT := Fxy2Pxy(WorkFT,ChildCStat.Wwidth,ChildCStat.Wheight);

  Work3D := PxyVz2Vxyz(WorkPT, Vz, ChildCStat.PPlainL, ChildCStat.PCameraL,
                       ChildCStat.LensType, ChildCStat.Offset2D, ChildCStat.Expan2D);

  tmp3d := Vxyz2Wxyz(Work3D, ChildCStat.Xtheta, ChildCStat.Ytheta,
                            ChildCStat.Offset3D);

//  op3d := MoveCenterPt.World;

  op3d := StartDragPt.World;

  tp3d := tmp3d;
  ocamstat := MainForm.DatStat_OldCam;
  ncamstat := ChildCStat;
  SafeArea := MainForm.AppStat_SafeArea;
  SafeDeg := MainForm.AppStat_SafeDeg;

//  if -1 = StartDragImm
//  then begin
//    ocamstat.Camera3D.X := -(ocamstat.Camera3D.X);
//    Mainform.DatStat_CmpCam.Camera3D.X := -(Mainform.DatStat_CmpCam.Camera3D.X);
//  end;

  MainForm.StatusBar.Panels[2].Text := Format('%dJ: %f %f %f',[ChildCStat.Immidiate,ChildCStat.Camera3D.X ,ChildCStat.Camera3D.Y ,ChildCStat.Camera3D.Z]);

  MainForm.StatusBar.Panels[4].Text := Format('%dJ: %f %f %f',[MainForm.DatStat_OldCam.Immidiate,MainForm.DatStat_OldCam.Camera3D.X ,MainForm.DatStat_OldCam.Camera3D.Y ,MainForm.DatStat_OldCam.Camera3D.Z]);

  MainForm.StatusBar.Panels[5].Text := Format('%dJ: %f %f %f',[Mainform.DatStat_CmpCam.Immidiate,Mainform.DatStat_CmpCam.Camera3D.X,Mainform.DatStat_CmpCam.Camera3D.Y,Mainform.DatStat_CmpCam.Camera3D.Z]);


  tmp3d := Make3d(op3d,tp3d,ocamstat,ncamstat,SafeArea,SafeDeg);


  if (tmp3d.X = tp3d.X)and(tmp3d.Y = tp3d.Y)and(tmp3d.Z = tp3d.Z)
  then begin
    MainForm.StatusBar.Panels[6].Text := Format('^_: %f %f %f',[op3d.X,op3d.Y,op3d.Z]);
    end
  else begin
    MainForm.StatusBar.Panels[6].Text := Format('V^_: %f %f %f',[op3d.X,op3d.Y,op3d.Z]);
  end;
  //

  New3DD.World := tmp3d;


  New3DD.Number := MainForm.MovingPoint;
  MoveCenterPt := New3DD;

  for i := 1 to MaxAryPoint
  do begin
    if 0 <> (PT_Selected and MainForm.Ary3DData[i].Status)
    then begin

      MainForm.Ary3DData[i].World.X := MainForm.Ary3DData[i].World.X
            + (MoveCenterPt.World.X - OldCenterPt.World.X);
      MainForm.Ary3DData[i].World.Y := MainForm.Ary3DData[i].World.Y
            + (MoveCenterPt.World.Y - OldCenterPt.World.Y);
      MainForm.Ary3DData[i].World.Z := MainForm.Ary3DData[i].World.Z
            + (MoveCenterPt.World.Z - OldCenterPt.World.Z);

      //

      tmp := MainForm.Ary3DData[i].Dim;
      if 0 <> tmp
      then begin
        MainForm.Ary3DData[tmp].World.X := -(MainForm.Ary3DData[i].World.X);
        MainForm.Ary3DData[tmp].World.Y :=  (MainForm.Ary3DData[i].World.Y);
        MainForm.Ary3DData[tmp].World.Z :=  (MainForm.Ary3DData[i].World.Z);
      end;

    end;
  end;
end;

//-----------------------------------------------------------------------------
// _1
//-----------------------------------------------------------------------------
procedure TMDIChild.RemPoint(SynmMode: Boolean);
var
  i, synI1, synI2: integer;
begin
  if 0 = MainForm.MovingPoint then exit;
  for i:= 2 to 254
  do begin // ̈ړ_̌
    if MKP_None = MainForm.MKPAry[i].Elder
    then begin
      synI1 := MainForm.Ary3DData[MainForm.MKPAry[i-1].PointNo].Dim;
      synI2 := MainForm.Ary3DData[MainForm.MKPAry[i-2].PointNo].Dim;
      if 2 = i
      then begin // ŏ̓_
        MainForm.Ary3DData[MainForm.MKPAry[0].PointNo].Status := PT_NULL;
        MainForm.Ary3DData[MainForm.MKPAry[1].PointNo].Status := PT_NULL;
        if SynmMode
        then begin
          //synI1 := MainForm.Ary3DData[MainForm.MKPAry[1].PointNo].Dim;
          //synI2 := MainForm.Ary3DData[MainForm.MKPAry[0].PointNo].Dim;
          MainForm.Ary3DData[synI2].Status := PT_NULL;
          MainForm.Ary3DData[synI1].Status := PT_NULL;
        end;
        MainForm.MovingPoint := 0;
      end
      else begin // ȍ~̓_
        if SynmMode
        then begin
          // s Ώ̓_s
          //synI1 := MainForm.Ary3DData[MainForm.MKPAry[i-1].PointNo].Dim;
          //synI2 := MainForm.Ary3DData[MainForm.MKPAry[i-2].PointNo].Dim;
          MainForm.Ary3DData[synI1].Dim := MainForm.Ary3DData[synI2].Dim;
          MainForm.Ary3DData[synI2] := MainForm.Ary3DData[synI1];
          MainForm.Ary3DData[synI2].Number := synI2;
          MainForm.Ary3DData[synI1].Status := PT_NULL;
        end;

        MainForm.Ary3DData[MainForm.MKPAry[i-1].PointNo].Dim :=
                MainForm.Ary3DData[MainForm.MKPAry[i-2].PointNo].Dim;
        MainForm.Ary3DData[MainForm.MKPAry[i-2].PointNo] :=
                MainForm.Ary3DData[MainForm.MKPAry[i-1].PointNo];
        MainForm.Ary3DData[MainForm.MKPAry[i-2].PointNo].Number :=
                MainForm.MKPAry[i-2].PointNo;
        MainForm.Ary3DData[MainForm.MKPAry[i-1].PointNo].Status := PT_NULL;
        MainForm.MKPAry[i-1].Elder := MKP_None;
        MainForm.MovingPoint := MainForm.MKPAry[i-2].PointNo;
      end;
      //RemLine();
      DelLine(MainForm.MKPAry[i-2].PointNo, MainForm.MKPAry[i-1].PointNo);
      if SynmMode
      then begin
        DelLine(synI2, synI1);
        //MainForm.Ary3DData[MainForm.MKPAry[i-2].PointNo].Dim,
        //MainForm.Ary3DData[MainForm.MKPAry[i-1].PointNo].Dim);
      end;
      break;
    end;
  end;
end;

//-----------------------------------------------------------------------------
// u
//-----------------------------------------------------------------------------
procedure TMDIChild.PutLine(P1, P2: integer);
var
//  i, NewN: integer;
//  New3DD: P3DData;
//  New3DD: T3DData;
//  Work3D: T3DPoint;
//  WorkPT: T2DPoint;
  NewL, AddL: P3DLine;
begin
  New(NewL);
  NewL.NextL := nil;
  NewL.Point1 := P1;
  NewL.Point2 := P2;
  NewL.View := 0;
  AddL := MainForm.Lnk3DLine;
  if nil = AddL
  then begin
    MainForm.Lnk3DLine := NewL;
  end
  else begin
    while nil <> AddL.NextL  do AddL := AddL.NextL;
    Addl.NextL := NewL;
  end;
end;

//-----------------------------------------------------------------------------
// 
//-----------------------------------------------------------------------------
procedure TMDIChild.DelLine(P1, P2: integer);
var
  workTop, workDel, workTmp : P3DLine;
begin
  New(workTop);
  workTop.NextL := MainForm.Lnk3DLine;
  workTmp := workTop;

  while nil <> workTmp.NextL
  do begin
    workDel := workTmp.NextL;
    if ((P1 = workDel.Point1) and (p2 = workDel.Point2)) or
       ((P2 = workDel.Point1) and (p1 = workDel.Point2))
    then begin
      workTmp.NextL := workDel.NextL;
      Dispose(workDel);
    end;
    workTmp := workTmp.NextL;
    if nil = workTmp then break;
  end;

  MainForm.Lnk3DLine := workTop.NextL;
  Dispose(workTop);
end;
//-----------------------------------------------------------------------------
// 1
//-----------------------------------------------------------------------------
procedure TMDIChild.RemLine();
var
  NewL, AddL: P3DLine;
begin
  AddL := MainForm.Lnk3DLine;
  if AddL <> nil
  then begin
    NewL := AddL.NextL;
    if NewL <> nil
    then begin
      while NewL.NextL <> nil
      do begin
        AddL := AddL.NextL;
        NewL := NewL.NextL;
      end;
      Dispose(NewL);
      AddL.NextL := nil;
    end
    else begin
      Dispose(AddL);
      MainForm.Lnk3DLine := nil;
    end;
  end;
end;

//-----------------------------------------------------------------------------
// 
//-----------------------------------------------------------------------------
procedure TMDIChild.WriteWindow();
begin
  imgWork.Canvas.FillRect(Rect(0,0,imgWork.Width, imgWork.Height));
  WriteCube();
  CalcPoint();
  WriteLine();
  WritePoint();

  imgView.Canvas.CopyRect(Rect(0,0,imgView.Width,imgView.Height),
                          imgWork.Canvas,
                          Rect(0,0,imgView.Width,imgView.Height));
end;

//-----------------------------------------------------------------------------
// ̂
//-----------------------------------------------------------------------------
procedure TMDIChild.WriteCube();
type
  TLinebuff = array[0..32767] of TPoint;

var
  linebuff : TLinebuff;
  lineSP : integer;

  i: integer;
  r3d,p3d,v3d : T3DPoint;
  r2d : T2DPoint;
  f2d : T2DPoint;

  p1,p2 : TPoint;
  tmp1,tmp2 : T2DPoint;
  p1p,p2p : integer;

begin
  for i:=1 to 18
  do begin

    r3d := Wxyz2Vxyz(CoreCube3DPoint[i].World,
                     ChildCStat.Xtheta, ChildCStat.Ytheta, ChildCStat.Offset3D);

    r2d := Vxyz2Pxy(r3d, ChildCStat.PPlainL, ChildCStat.PCameraL,
                    ChildCStat.LensType, ChildCStat.Offset2D, ChildCStat.Expan2D);


    f2d := Pxy2Fxy(r2d , ChildCStat.Wwidth ,ChildCStat.Wheight);


    CoreCube3DPoint[i].Flat.x := Roundoff(f2d.X);
    CoreCube3DPoint[i].Flat.y := Roundoff(f2d.Y);



  end;

  with imgWork.Canvas do
  begin
    FillRect(Rect(0,0,imgWork.Width, imgWork.Height));

    Pen.Color := clLime;
    for i:=1 to 17
    do begin

    p1p := CoreCube3DLine[i].Point1;
    p2p := CoreCube3DLine[i].Point2;

    p1 := CoreCube3DPoint[p1p].Flat;
    p2 := CoreCube3DPoint[p2p].Flat;


    tmp1.X := CoreCube3DPoint[p1p].Flat.X;
    tmp1.Y := CoreCube3DPoint[p1p].Flat.Y;
    tmp2.X := CoreCube3DPoint[p2p].Flat.X;
    tmp2.Y := CoreCube3DPoint[p2p].Flat.Y;

    if len2d(tmp1,tmp2) > Mainform.AppStat_LineDivLength
    then begin

        p3d := Wxyz2Vxyz(CoreCube3DPoint[p1p].World,
                     ChildCStat.Xtheta, ChildCStat.Ytheta, ChildCStat.Offset3D);

        v3d := Wxyz2Vxyz(CoreCube3DPoint[p2p].World,
                     ChildCStat.Xtheta, ChildCStat.Ytheta, ChildCStat.Offset3D);

        imgWork.Canvas.Pen.Color := clLime;

//        imgWork.Canvas.MoveTo(Roundoff(p1.X),Roundoff(p1.Y));

        lineSP := 0;

        linebuff[lineSP].X:=Roundoff(p1.X);
        linebuff[lineSP].Y:=Roundoff(p1.Y);
        inc(lineSP);

//        callLdiv(p3d,v3d, Mainform.AppStat_LineDivLength);
        callLdiv(p3d,v3d, Mainform.AppStat_LineDivLength, linebuff,lineSP);

//        imgWork.Canvas.LineTo(Roundoff(p2.X),Roundoff(p2.Y));

        linebuff[lineSP].X:=Roundoff(p2.X);
        linebuff[lineSP].Y:=Roundoff(p2.Y);
        inc(lineSP);

        imgWork.Canvas.Polyline(Slice(linebuff, lineSP));

        lineSP := 0;


    end
    else begin

      Polyline([CoreCube3DPoint[CoreCube3DLine[i].Point1].Flat,
                CoreCube3DPoint[CoreCube3DLine[i].Point2].Flat]);
    end;

    end;
  end;
//  imgView.Canvas.CopyRect(Rect(0,0,imgView.Width,imgView.Height),
//                          imgWork.Canvas,
//                          Rect(0,0,imgView.Width,imgView.Height));
end;

//-----------------------------------------------------------------------------
// _
//-----------------------------------------------------------------------------
procedure TMDIChild.WritePoint();
var
  i: integer;
begin
  MainForm.Ary3DData[0] := MoveCenterPt;
  for i := MaxAryPoint downto 0     //0͏dSAԏɏ̂downto
  do begin
    if 0 <> (PT_Alived and MainForm.Ary3DData[i].Status)
    then begin
      // œ_`
      if 0 <> (PT_Selected and MainForm.Ary3DData[i].Status)
      then imgWork.Canvas.Pen.Color := clMaroon
      else imgWork.Canvas.Pen.Color := clBlack;

      if 0 = i then imgWork.Canvas.Pen.Color := clRed;  //0͏dS ɐ

      imgWork.Canvas.Polyline([Point(MainForm.Ary3DData[i].Flat.X-1, MainForm.Ary3DData[i].Flat.Y-1),
                               Point(MainForm.Ary3DData[i].Flat.X+1, MainForm.Ary3DData[i].Flat.Y-1),
                               Point(MainForm.Ary3DData[i].Flat.X+1, MainForm.Ary3DData[i].Flat.Y+1),
                               Point(MainForm.Ary3DData[i].Flat.X-1, MainForm.Ary3DData[i].Flat.Y+1),
                               Point(MainForm.Ary3DData[i].Flat.X-1, MainForm.Ary3DData[i].Flat.Y-1)]);
    end;
  end;


{  for i:=0 to MainForm.CountTemp - 1
  do begin
    if 0 <> (PT_Alived and MainForm.Ary3DTemp[i].Status)
    then begin
      // œ_`
      imgWork.Canvas.Pen.Color := clBlack;
      imgWork.Canvas.Polyline([Point(MainForm.Ary3DTemp[i].Flat.X-1, MainForm.Ary3DTemp[i].Flat.Y-1),
                               Point(MainForm.Ary3DTemp[i].Flat.X+1, MainForm.Ary3DTemp[i].Flat.Y-1),
                               Point(MainForm.Ary3DTemp[i].Flat.X+1, MainForm.Ary3DTemp[i].Flat.Y+1),
                               Point(MainForm.Ary3DTemp[i].Flat.X-1, MainForm.Ary3DTemp[i].Flat.Y+1),
                               Point(MainForm.Ary3DTemp[i].Flat.X-1, MainForm.Ary3DTemp[i].Flat.Y-1)]);
    end;
  end;}
end;

//-----------------------------------------------------------------------------
// 
//-----------------------------------------------------------------------------
procedure TMDIChild.WriteLine();
type
  TLinebuff = array[0..32767] of TPoint;

var
  linebuff : TLinebuff;
  lineSP : integer;

  linebuff2 : TLinebuff;
  lineSP2 : integer;

  lpP3DL: P3DLine;
  tmp1, tmp2: T2DPoint;
  p1, p2: TPoint;
  p1p, p2p: integer;

  p3d,v3d : T3DPoint;
  i: integer;

begin

  lpP3DL := MainForm.Lnk3DLine;

  while lpP3DL <> nil
  do begin

    for i := 1 to MaxAryPoint
    do begin
      if lpP3DL.Point1 = MainForm.Ary3DData[i].Number
      then begin
        p1:= MainForm.Ary3DData[i].Flat;
        p1p := i;

        break;
      end;
    end;
    for i := 1 to MaxAryPoint
    do begin
      if lpP3DL.Point2 = MainForm.Ary3DData[i].Number
      then begin
        p2:= MainForm.Ary3DData[i].Flat;
        p2p := i;

        break;
      end;
    end;

//
    tmp1.X := p1.X;
    tmp1.Y := p1.Y;
    tmp2.X := p2.X;
    tmp2.Y := p2.Y;

    if len2d(tmp1,tmp2) > Mainform.AppStat_LineDivLength*1000
    then begin

      if 0 = lpP3DL.View
      then begin
        lineSP := 0;

        p3d := Wxyz2Vxyz(MainForm.Ary3DData[p1p].World,
                     ChildCStat.Xtheta, ChildCStat.Ytheta, ChildCStat.Offset3D);

        v3d := Wxyz2Vxyz(MainForm.Ary3DData[p2p].World,
                     ChildCStat.Xtheta, ChildCStat.Ytheta, ChildCStat.Offset3D);

        imgWork.Canvas.Pen.Color := clBlack;

//        imgWork.Canvas.MoveTo(Roundoff(p1.X),Roundoff(p1.Y));

        linebuff[lineSP].X:=Roundoff(p1.X);
        linebuff[lineSP].Y:=Roundoff(p1.Y);
        inc(lineSP);

//        callLdiv(p3d,v3d, Mainform.AppStat_LineDivLength);
       callLdiv(p3d,v3d, Mainform.AppStat_LineDivLength,linebuff,lineSP);


        linebuff[lineSP].X:=Roundoff(p2.X);
        linebuff[lineSP].Y:=Roundoff(p2.Y);
        inc(lineSP);

//        imgWork.Canvas.LineTo(Roundoff(p2.X),Roundoff(p2.Y));

        imgWork.Canvas.Pen.Color := clBlack;
        imgWork.Canvas.Polyline(Slice(linebuff, lineSP));


        lineSP := 0;



      end;
      lpP3DL := lpP3DL.NextL;

//      imgWork.Canvas.PolyBezier([p1,p2]);
    end


    else begin

      if 0 = lpP3DL.View
      then begin
        imgWork.Canvas.Pen.Color := clBlack;
        imgWork.Canvas.Polyline([p1,p2]);

//        imgWork.Canvas.PolyBezier([p1,p2]);
      end;
      lpP3DL := lpP3DL.NextL;
    end;
  end;

end;

//-----------------------------------------------------------------------------
// ċAĂяo
//-----------------------------------------------------------------------------
procedure TMDIChild.callLdiv(p3d,v3d: T3DPoint; Pdist: integer;
                   var linebuff: array of TPoint; var lineSP: integer);

//procedure TMDIChild.callLdiv(p3d,v3d: T3DPoint; Pdist: integer);

var
  p2d,p2df : T2DPoint;
  v2d,v2df : T2DPoint;
  d3d : T3DPoint;
  d2d,d2df : T2DPoint;

  lpd,ldv : double;

begin

//_ÅԂ̓_߁Aꂼ̃sNZWƂ̋߂

      p2d := Vxyz2Pxy(p3d, ChildCStat.PPlainL, ChildCStat.PCameraL,
                      ChildCStat.LensType, ChildCStat.Offset2D, ChildCStat.Expan2D);

      p2df := Pxy2Fxy(p2d, ChildCStat.Wwidth,ChildCStat.Wheight);


      v2d := Vxyz2Pxy(v3d, ChildCStat.PPlainL, ChildCStat.PCameraL,
                      ChildCStat.LensType, ChildCStat.Offset2D, ChildCStat.Expan2D);

      v2df := Pxy2Fxy(v2d, ChildCStat.Wwidth,ChildCStat.Wheight);

        d3d.X := (p3d.X + v3d.X) / 2;
        d3d.Y := (p3d.Y + v3d.Y) / 2;
        d3d.Z := (p3d.Z + v3d.Z) / 2;

      d2d := Vxyz2Pxy(d3d, ChildCStat.PPlainL, ChildCStat.PCameraL,
                      ChildCStat.LensType, ChildCStat.Offset2D, ChildCStat.Expan2D);

      d2df := Pxy2Fxy(d2d, ChildCStat.Wwidth,ChildCStat.Wheight);

      lpd := len2d(p2df,d2df);
      ldv := len2d(d2df,v2df);

//      if lpd > Pdist then callLdiv(p3d,d3d, Pdist);
      if lpd > Pdist then callLdiv(p3d,d3d, Pdist,linebuff,lineSP);

//        imgWork.Canvas.LineTo(Roundoff(d2df.X),Roundoff(d2df.Y));

        linebuff[lineSP].X:=Roundoff(d2df.X);
        linebuff[lineSP].Y:=Roundoff(d2df.Y);
        inc(lineSP);


//      if ldv > Pdist then callLdiv(d3d,v3d, Pdist);
      if ldv > Pdist then callLdiv(d3d,v3d, Pdist,linebuff,lineSP);

end;




//-----------------------------------------------------------------------------
// ̂̃Clݒ
//-----------------------------------------------------------------------------
procedure TMDIChild.SetCC3DLines;
begin
  CoreCube3DLine[1].Point1 := 1;
  CoreCube3DLine[1].Point2 := 2;

  CoreCube3DLine[2].Point1 := 3;
  CoreCube3DLine[2].Point2 := 2;

  CoreCube3DLine[3].Point1 := 3;
  CoreCube3DLine[3].Point2 := 4;

  CoreCube3DLine[4].Point1 := 1;
  CoreCube3DLine[4].Point2 := 4;

  CoreCube3DLine[5].Point1 := 1;
  CoreCube3DLine[5].Point2 := 5;

  CoreCube3DLine[6].Point1 := 6;
  CoreCube3DLine[6].Point2 := 5;

  CoreCube3DLine[7].Point1 := 6;
  CoreCube3DLine[7].Point2 := 7;

  CoreCube3DLine[8].Point1 := 8;
  CoreCube3DLine[8].Point2 := 7;

  CoreCube3DLine[9].Point1 := 8;
  CoreCube3DLine[9].Point2 := 5;

  CoreCube3DLine[10].Point1 := 6;
  CoreCube3DLine[10].Point2 := 2;

  CoreCube3DLine[11].Point1 := 3;
  CoreCube3DLine[11].Point2 := 7;

  CoreCube3DLine[12].Point1 := 8;
  CoreCube3DLine[12].Point2 := 4;

  CoreCube3DLine[13].Point1 := 9;
  CoreCube3DLine[13].Point2 := 10;

  CoreCube3DLine[14].Point1 := 11;
  CoreCube3DLine[14].Point2 := 12;

  CoreCube3DLine[15].Point1 := 13;
  CoreCube3DLine[15].Point2 := 14;

  CoreCube3DLine[16].Point1 := 15;
  CoreCube3DLine[16].Point2 := 16;

  CoreCube3DLine[17].Point1 := 17;
  CoreCube3DLine[17].Point2 := 18;
end;

//-----------------------------------------------------------------------------
// ̂̃|Cglݒ
//-----------------------------------------------------------------------------
procedure TMDIChild.SetCC3DPoint;
begin
  CoreCube3DPoint[1].World.X := -1;
  CoreCube3DPoint[1].World.Y := -1;
  CoreCube3DPoint[1].World.Z :=  1;

  CoreCube3DPoint[2].World.X :=  1;
  CoreCube3DPoint[2].World.Y := -1;
  CoreCube3DPoint[2].World.Z :=  1;

  CoreCube3DPoint[3].World.X :=  1;
  CoreCube3DPoint[3].World.Y := -1;
  CoreCube3DPoint[3].World.Z := -1;

  CoreCube3DPoint[4].World.X := -1;
  CoreCube3DPoint[4].World.Y := -1;
  CoreCube3DPoint[4].World.Z := -1;

  CoreCube3DPoint[5].World.X := -1;
  CoreCube3DPoint[5].World.Y :=  1;
  CoreCube3DPoint[5].World.Z :=  1;

  CoreCube3DPoint[6].World.X :=  1;
  CoreCube3DPoint[6].World.Y :=  1;
  CoreCube3DPoint[6].World.Z :=  1;

  CoreCube3DPoint[7].World.X :=  1;
  CoreCube3DPoint[7].World.Y :=  1;
  CoreCube3DPoint[7].World.Z := -1;

  CoreCube3DPoint[8].World.X := -1;
  CoreCube3DPoint[8].World.Y :=  1;
  CoreCube3DPoint[8].World.Z := -1;

  CoreCube3DPoint[ 9].World.X :=  1;
  CoreCube3DPoint[ 9].World.Y :=  1;
  CoreCube3DPoint[ 9].World.Z :=  0;

  CoreCube3DPoint[10].World.X := -1;
  CoreCube3DPoint[10].World.Y :=  1;
  CoreCube3DPoint[10].World.Z :=  0;

  CoreCube3DPoint[11].World.X :=  0;
  CoreCube3DPoint[11].World.Y :=  1;
  CoreCube3DPoint[11].World.Z := -1;

  CoreCube3DPoint[12].World.X :=  0;
  CoreCube3DPoint[12].World.Y :=  1;
  CoreCube3DPoint[12].World.Z :=  1;

  CoreCube3DPoint[13].World.X :=  1;
  CoreCube3DPoint[13].World.Y :=  0;
  CoreCube3DPoint[13].World.Z :=  1;

  CoreCube3DPoint[14].World.X := -1;
  CoreCube3DPoint[14].World.Y :=  0;
  CoreCube3DPoint[14].World.Z :=  1;

  CoreCube3DPoint[15].World.X :=  0;
  CoreCube3DPoint[15].World.Y := -1;
  CoreCube3DPoint[15].World.Z :=  0;

  CoreCube3DPoint[16].World.X :=  0;
  CoreCube3DPoint[16].World.Y :=  1;
  CoreCube3DPoint[16].World.Z :=  0;

  CoreCube3DPoint[17].World.X := -1;
  CoreCube3DPoint[17].World.Y :=  0;
  CoreCube3DPoint[17].World.Z :=  0;

  CoreCube3DPoint[18].World.X :=  1;
  CoreCube3DPoint[18].World.Y :=  0;
  CoreCube3DPoint[18].World.Z :=  0;

end;

//-----------------------------------------------------------------------------
// zC[O
//-----------------------------------------------------------------------------

procedure TMDIChild.FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);

var
  newPCL,newPPL,oldPCL,oldPPL : Double;

begin
  if ssShift in Shift
  then begin

  oldPPL := ChildCStat.PPlainL;
  oldPCL := ChildCStat.PCameraL;
  newPCL := ChildCStat.PCameraL + 0.5;

  newPPL := (newPCL /(oldPCL / (oldPPL+oldPCL))) - newPCL;

  ChildCStat.PCameraL := newPCL;
  ChildCStat.PPlainL := newPPL;

  end
  else begin

  ChildCStat.PPlainL  :=   ChildCStat.PPlainL + 0.5;

  ChildCStat.Camera3D :=CheckCamera3d(ChildCStat);
  MainForm.StatusBar.Panels[2].Text := Format('%dJ: %f %f %f',[ChildCStat.Immidiate,ChildCStat.Camera3D.X ,ChildCStat.Camera3D.Y ,ChildCStat.Camera3D.Z]);

  end;
end;


//-----------------------------------------------------------------------------
// zC[
//-----------------------------------------------------------------------------

procedure TMDIChild.FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);

var
  newPCL,newPPL,oldPCL,oldPPL : Double;

begin
  if ssShift in Shift
  then begin

    if ChildCStat.PCameraL >1
    then begin
      oldPPL := ChildCStat.PPlainL;
      oldPCL := ChildCStat.PCameraL;
      newPCL := ChildCStat.PCameraL - 0.5;

      newPPL := (newPCL /(oldPCL / (oldPPL+oldPCL))) - newPCL;

      ChildCStat.PCameraL := newPCL;
      ChildCStat.PPlainL := newPPL;
    end;

  end
  else begin

    if ChildCStat.PPlainL > 0.5
    then begin
      ChildCStat.PPlainL  :=   ChildCStat.PPlainL - 0.5;

      ChildCStat.Camera3D :=CheckCamera3d(ChildCStat);
      MainForm.StatusBar.Panels[2].Text := Format('%dJ: %f %f %f',[ChildCStat.Immidiate,ChildCStat.Camera3D.X ,ChildCStat.Camera3D.Y ,ChildCStat.Camera3D.Z]);
    end;

  end;

end;

end.
