unit locater;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
          header;

type
  TLocaterForm = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormResize(Sender: TObject);
  private
    { Private 錾 }
    IsMouseDown : boolean;  // }EX
    OldCursorX,             // J[\\p
    OldCursorY : integer;   // ȑÕJ[\ʒu
    Keido,        // ox
    Ido : double; // ܓx
    procedure WriteCursor(); // J[\\
    procedure WriteForm();   // tH[`
    Procedure CalcIdoKeido(X, Y: Integer; Shift: TShiftState); // ܓxoxvZ
  public
    { Public 錾 }
    Procedure SetIdoKeido(FormX, FormY: double); // ܓxoxvZ
  end;

var
  LocaterForm: TLocaterForm;

implementation

uses Main, Childwin, Math;

{$R *.DFM}

//-----------------------------------------------------------------------------
// NGCg
//-----------------------------------------------------------------------------
procedure TLocaterForm.FormCreate(Sender: TObject);
begin
  Canvas.Brush.Color := clBtnFace;
  IsMouseDown := False;
  Keido := 0.0;
  Ido := 0.0;
  OldCursorX := ClientWidth div 2;
  OldCursorY := ClientHeight div 2;
  show;
end;

//-----------------------------------------------------------------------------
// yCg
//-----------------------------------------------------------------------------
procedure TLocaterForm.FormPaint(Sender: TObject);
begin
  WriteForm;
end;

//-----------------------------------------------------------------------------
// }EX{^_E
//-----------------------------------------------------------------------------
procedure TLocaterForm.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  IsMouseDown := True;
  CalcIdoKeido(X, Y, Shift);

end;

//-----------------------------------------------------------------------------
// }EX{^[u
//-----------------------------------------------------------------------------
procedure TLocaterForm.FormMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  if IsMouseDown = True
  then begin
    CalcIdoKeido(X, Y, Shift);
  end;
end;

//-----------------------------------------------------------------------------
// }EX{^Abv
//-----------------------------------------------------------------------------
procedure TLocaterForm.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  IsMouseDown := False;
  CalcIdoKeido(X, Y, Shift);
end;

//-----------------------------------------------------------------------------
// TCY
//-----------------------------------------------------------------------------
procedure TLocaterForm.FormResize(Sender: TObject);
begin
  WriteCursor;
  WriteForm;
end;

//-----------------------------------------------------------------------------
// S̏Ȃ
//-----------------------------------------------------------------------------
procedure TLocaterForm.WriteForm();
begin
  // NA
  Canvas.FillRect(rect(0,0,ClientWidth,ClientHeight));

  // \
  Canvas.Pen.Mode := pmBlack;
  Canvas.MoveTo(1, ClientHeight div 2);
  Canvas.LineTo(ClientWidth, ClientHeight div 2);
  Canvas.MoveTo(ClientWidth div 2, 1);
  Canvas.LineTo(ClientWidth div 2, ClientHeight);

  // g
  Canvas.MoveTo(1, 1);
  Canvas.LineTo(ClientWidth-1, 1);
  Canvas.LineTo(ClientWidth-1, ClientHeight-1);
  Canvas.LineTo(1,             ClientHeight-1);
  Canvas.LineTo(1,             1);

  // J[\
  Canvas.Pen.Mode := pmNotXor;
  Canvas.MoveTo(OldCursorX-3, OldCursorY-3);
  Canvas.LineTo(OldCursorX+4, OldCursorY+4);
  Canvas.MoveTo(OldCursorX-3, OldCursorY+3);
  Canvas.LineTo(OldCursorX+4, OldCursorY-4);
end;

//-----------------------------------------------------------------------------
// J[\`
//-----------------------------------------------------------------------------
procedure TLocaterForm.WriteCursor;
var
  CenterX, CenterY : integer;
  x64, y64 : int64;
begin
  x64 := (Round(Keido  / PI * 180 * 10) mod 3600);
  y64 := -(Round(Ido  / PI * 180 * 10) mod 1800);

  // S_vZ(X)
  if x64 < 0
  then begin
    if x64 < -1800
    then
      CenterX := (ClientWidth div 2) +
                 Round(((x64 + 3600) / 1800) * (ClientWidth div 2))
    else
      CenterX := (ClientWidth div 2) +
                 Round((x64 / 1800) * (ClientWidth div 2));
  end
  else begin
    if x64 > 1800
    then
      CenterX := (ClientWidth div 2) +
                 Round(((x64 - 3600) / 1800) * (ClientWidth div 2))
    else
      CenterX := (ClientWidth div 2) +
                 Round((x64 / 1800) * (ClientWidth div 2));
  end;

  // S_vZ(Y)
  if y64 < 0
  then begin
    if y64 < -900
    then
      CenterY := (ClientHeight div 2) +
                 Round(((y64 + 1800) / 900) * (ClientHeight div 2))
    else
      CenterY := (ClientHeight div 2) +
                 Round((y64 / 900) * (ClientHeight div 2));
  end
  else begin
    if y64 > 900
    then
      CenterY := (ClientHeight div 2) +
                 Round(((y64 - 1800) / 900) * (ClientHeight div 2))
    else
      CenterY := (ClientHeight div 2) +
                 Round((y64 / 900) * (ClientHeight div 2));
  end;

  // J[\`
  Canvas.Pen.Mode := pmNotXor;
  Canvas.MoveTo(OldCursorX-3, OldCursorY-3);
  Canvas.LineTo(OldCursorX+4, OldCursorY+4);
  Canvas.MoveTo(OldCursorX-3, OldCursorY+3);
  Canvas.LineTo(OldCursorX+4, OldCursorY-4);

  Canvas.MoveTo(CenterX-3, CenterY-3);
  Canvas.LineTo(CenterX+4, CenterY+4);
  Canvas.MoveTo(CenterX-3, CenterY+3);
  Canvas.LineTo(CenterX+4, CenterY-4);

  // ۑ
  OldCursorX := CenterX;
  OldCursorY := CenterY;
end;

//-----------------------------------------------------------------------------
// ܓxoxvZ
//-----------------------------------------------------------------------------
procedure TLocaterForm.CalcIdoKeido(X, Y: Integer; Shift: TShiftState);
begin
//  Keido := (X - (ClientWidth div 2)) / ClientWidth * 360;
//  Ido := -(Y - (ClientHeight div 2)) / ClientHeight * 180;
  Keido := (X - (ClientWidth div 2)) / ClientWidth * 2 * PI;
  Ido := -(Y - (ClientHeight div 2)) / ClientHeight * PI;


  if ssShift in Shift
  then begin
    Keido := Floor((Keido + (45*Pi)/360) / (Pi/4) ) * (Pi / 4);
    ido := Floor((ido + (45*Pi)/360) / (Pi/4) ) * (Pi / 4);

  end;


  WriteCursor;

  // pl̔ԍɒ
  MainForm.StatusBar.Panels[1].Text := Format('px: %f, %f',[Keido / PI * 180, Ido / PI * 180]);
  if MainForm.MDIChildCount > 0
  then begin  // ANeButH[
//    (MainForm.MDIChildren[0] as TMDIChild).WriteChild(Keido, -Ido);
    (MainForm.MDIChildren[0] as TMDIChild).WriteChild(Ido, Keido);
  end;

end;

//-----------------------------------------------------------------------------
// ܓxoxZbg
//-----------------------------------------------------------------------------
procedure TLocaterForm.SetIdoKeido(FormX, FormY: double);
begin
  Keido := FormY;
  Ido := FormX;
  WriteCursor;

  // pl̔ԍɒ
  MainForm.StatusBar.Panels[1].Text := Format('px: %f, %f',[Keido / PI * 180, Ido / PI * 180]);
end;

end.
